%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Copyright 2014 Sanjib Sur (sur2 at wisc.edu), Xinyu Zhang (xyzhang at ece.wisc.edu)
% This project is Licensed under the the GNU General Public License (see LICENSE.txt)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [rssi] = calculate_rssi(d_e_squared)

%% Read global variables
adsssGlobalVars;


%% Find RSSI
rssi_linear = round(d_e_squared / (RSSI_AVE_COUNT * 10.0));
d_rssi = RSSI_MAX;

for j = 0:15
    if bitand(rssi_linear,  hex2dec('c0000000'), 'uint32')
        break;
    end
    rssi_linear = bitshift(rssi_linear, 2, 'uint32');
    d_rssi = d_rssi - 6;
end

rssi_linear = bitshift(rssi_linear, -(32 - 6), 'uint32');
rssi_linear = bitand(rssi_linear, hex2dec('3f'), 'uint32');
d_rssi = d_rssi + LOG_TABLE(rssi_linear + 1);

% if d_rssi < 0
%    d_rssi = -bitshift(-d_rssi, 8, 'uint16'); 
% else
%     d_rssi = bitshift(d_rssi, 8, 'uint16');
% end

rssi = d_rssi;
end